;MASSANBO.lsp---Schreibt an den gewhlten Bogen:.................
;               Radius od. Bogenlnge od. Bogenlnge , Radius....
;W. Meyer      ..................................................
;U. Teichmann  ..................................................
;Textstil wie <Aktuell>..........................................
;Texthhe     <2.5 oder 3.5> (je nach Voreinstellung in Zeile xx)
;Textfarbe    <vonLayer>.........................................
;Layer        <BEM>..............................................
;Stellen wie  <Einheiten>........................................
;*****************************************************************************

(defun c:MASSANBO (/ cen rad a1 a2 rb a3 a4 u l rad1 pt a5 lt radt)

 (if (or (= mxy nil)(= mxy 0.0))
  (setq mxy (getreal "\nDen Mastab dieser Zeichnung eingeben  1: ? "))
 )
 (setq H1 (* mxy 2.5))				;;;Voreinstellung Zeile xx

;;;FEHLERBEHANDLUNGSROUTINE
 (defun *error* (msg) 
  (command "_clayer" alay "_cecolor" acol "_celtype" altp)
  (setvar "osmode" aosm)
  (command "_ucs" "_prev")
  (princ msg)(princ)
 )

;;;SYSTEMVARIABLEN SETZEN
 (setq alay (getvar "clayer"))
 (setq acol (getvar "cecolor"))
 (setq altp (getvar "celtype"))
 (setq aosm (getvar "osmode"))
 (setvar "osmode" 0)
 (setvar "cmdecho" 0)
 (command "_ucs" "_w")

;------Auswhlen--------------------------------------------------------------
 (princ "\nDas Programm Schreibt...auf dem Layer BEM...")
 (princ "mittig an den gewhlten Bogen:")
 (if (not rx)(setq rx "R"))
 (initget "R B RB")
 (setq rb
  (getkword 
   (strcat "\nR= (R)           Bogl.= (B)           R= , Bogl.= (RB)          ?   <"rx">  : ")
  )
 )
 (if (not rb)(setq rb rx))

 (setq auen_innen nil)
 (initget "Auerhalb Innerhalb")
 (setq auen_innen (getkword "\nAuerhalb / Innerhalb  ? <A>: "))
 (if (= auen_innen "Auerhalb") (setq auen_innen nil))

 (setq bog (entget (car (entsel "\nBogen whlen: "))))

;------Info. extrahieren------------------------------------------------------
 (setq cen (cdr (assoc 10 bog)))
 (setq rad (cdr (assoc 40 bog)))
 (setq a1 (cdr (assoc 50 bog)))
 (setq a2 (cdr (assoc 51 bog)))

;------Berechnen--------------------------------------------------------------
 (setq a3 (- a2 a1))				;;;geom. Winkel in PI
 (setq a4 (+ a1 (/ a3 2)))
 (if (< a2 a1)					;;;sonst falscher Wert
  (setq a3 (+ a2 (- (* pi 2) a1)))
 )
 (setq u (* pi 2 rad))
 (setq l (/ (* u a3)(* pi 2)))

 (setq rad1
  (if (null auen_innen)
   (+ rad H1	)				;;;auerhalb des Bogens
   (- rad H1)					;;;innerhalb des Bogens
  )
 )

 (setq PT (polar cen a4 rad1))
 (if (< a2 a1)					;;;sonst Text gegenberliegend
  (setq PT (polar cen (+ a4 pi) rad1))
 )

 (setq a4 (/ (* a4 180) pi))			;;;Textwinkel in Grad
 (if (< a4 180)
  (setq a5 (- a4 90))
  (setq a5 (+ a4 90))
 )

;------Textbearbeitung--------------------------------------------------------
 (setq lt (rtos l))
 (setq radt (rtos rad))
 (cond
  ((= rb "R")					;;;gewnscht R=
   (setq TXT (strcat "R="radt))(setq rx "R")
  )
  ((= rb "B")					;;;gewnscht Bogl.=
   (setq TXT (strcat "Bogl.="lt))(setq rx "B")
  )
  ((= rb "RB")					;;;gewnscht R= , Bogl.=
   (setq TXT (strcat "R="radt " , Bogl.="lt))(setq rx "RB")
  )
 )
 (command "_clayer" "BEM" "_cecolor" 256 "_celtype" "bylayer")
 (command "_.text" "_m" PT H1 A5 TXT)

;;;SYSTEMVARIABLEN ZURCKSETZEN
 (command "_clayer" alay "_cecolor" acol "_celtype" altp)
 (setvar "osmode" aosm)
 (command "_ucs" "_prev")

 (terpri)
 (princ TXT)
 (princ)
)						;;;defun

;------Beispiel fr Bogenwerte------------------------------------------------

;(defun arc-info (ent / lst cen rad ang1 ang2 p1 p2 len chord)
; (setq	lst   (entget ent)
;	cen   (cdr (assoc 10 lst))  ; center point
;	rad   (cdr (assoc 40 lst))  ; radius
;	ang1  (cdr (assoc 50 lst))  ; start angle
;	ang2  (cdr (assoc 51 lst))  ; end angle
;	inc   (abs (- ang1 ang2))   ; included angle
;	p1    (polar cen ang1 rad)  ; start point
;	p2    (polar cen ang2 rad)  ; end point
;	len   (* (/ inc (* 2 pi))   ; arc length: (included angle / 360) * circumference
;		 (* 2 (* pi rad))
;	      )
;	chord (distance p1 p2)      ; chord length
;  )
;  (list p1 p2 len chord)
;)